#include <string.h>
#include <gba.h>

#include "place.h"

#define constrain(amt,low,high) ((amt)<(low)?(low):((amt)>(high)?(high):(amt)))

int cx = 0;
int cy = 0;

BGAffineSource zoom = {
    //Center Of Rotation In Original Image (Last 8-Bits Fractional)
    .x = 0x00000000, // X
    .y = 0x00000000, // Y
    // Center Of Rotation On Screen
    .tX = 0x0000, // X
    .tY = 0x0000, // Y
    // Scaling Ratios (Last 8-Bits Fractional)
    .sX = 0x0100, // X
    .sY = 0x0100, // Y
    // Angle Of Rotation ($0000..$FFFF Anti-Clockwise)
    .theta = 0x0000,
};

int main(void) {
    irqInit();
    irqEnable(IRQ_VBLANK);

    REG_DISPCNT = MODE_3 | BG2_ENABLE;

    for (int y = 0; y < 160; y++) {
        dmaCopy(&place[y*place_width], (u16*)(VRAM + y*240*2), 240*2);
    }

    while (true) {
        u16 keys = ~REG_KEYINPUT;

        if (keys) {
            int d = 1;
            if (keys & ((1 << 0) | (1 << 1))) d = 3;
            if (keys & (1 << 6)) cy -= d;
            if (keys & (1 << 7)) cy += d;
            if (keys & (1 << 5)) cx -= d;
            if (keys & (1 << 4)) cx += d;
            if (keys & (1 << 8)) {zoom.sX -= 4; zoom.sY -= 4;}
            if (keys & (1 << 9)) {zoom.sX += 4; zoom.sY += 4;}

            cx = constrain(cx, 0, place_width - 240);
            cy = constrain(cy, 0, place_height - 160);
            zoom.sX = constrain(zoom.sX, 0, 0x0100);
            zoom.sY = constrain(zoom.sY, 0, 0x0100);

            zoom.tX = (double)cx/(place_width - 240) * 240;
            zoom.x = zoom.tX << 8;
            zoom.tY = (double)cy/(place_height - 160) * 160;
            zoom.y = zoom.tY << 8;

            for (int y = 0; y < 160; y++) {
                dmaCopy(&place[(y + cy)*place_width + cx], (u16*)(VRAM + y*240*2), 240*2);
            }
            VBlankIntrWait();

            BgAffineSet(&zoom, (BGAffineDest*)&REG_BG2PA, 1);
        }
    }
}
